<html>
<head>
<title>OGRE: OgreWindowEventUtilities.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreWindowEventUtilities.h</h1><a href="OgreWindowEventUtilities_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __OgreWindowEventUtils_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __OgreWindowEventUtils_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePlatform_8h.html">OgrePlatform.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#  define WIN32_LEAN_AND_MEAN</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;windows.h&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#  undef NOMINMAX</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#  define NOMINMAX // required to stop windows.h screwing up std::min definition</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="keyword">namespace </span>Ogre
<a name="l00043"></a>00043 {
<a name="l00048"></a><a class="code" href="classOgre_1_1WindowEventListener.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WindowEventListener.html" title="Callback class used to send out window events to client app">WindowEventListener</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classOgre_1_1WindowEventListener.html#908a45e8cf9e3c5f35988abed57b12da">00051</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1WindowEventListener.html" title="Callback class used to send out window events to client app">WindowEventListener</a>() {};
<a name="l00052"></a>00052 
<a name="l00059"></a><a class="code" href="classOgre_1_1WindowEventListener.html#bf7a3cb2023860d55367c9ed337d386c">00059</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowMoved(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)   {}
<a name="l00060"></a>00060 
<a name="l00067"></a><a class="code" href="classOgre_1_1WindowEventListener.html#87d8fa99072dfdb5d3b0b26a7cfd0120">00067</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowResized(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw) {}
<a name="l00068"></a>00068 
<a name="l00075"></a><a class="code" href="classOgre_1_1WindowEventListener.html#d18f2f48f1d6f501b05ffd9e9a782590">00075</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowClosed(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)  {}
<a name="l00076"></a>00076 
<a name="l00083"></a><a class="code" href="classOgre_1_1WindowEventListener.html#8a1cf8cba40a4b84db339ccb02c0bf3c">00083</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowFocusChange(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw) {}
<a name="l00084"></a>00084     };
<a name="l00085"></a>00085 
<a name="l00090"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html">00090</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WindowEventUtilities.html" title="Utility class to handle Window Events/Pumping/Messages">WindowEventUtilities</a>
<a name="l00091"></a>00091     {
<a name="l00092"></a>00092     <span class="keyword">public</span>:
<a name="l00098"></a>00098         <span class="keyword">static</span> <span class="keywordtype">void</span> messagePump();
<a name="l00099"></a>00099 
<a name="l00110"></a>00110         <span class="keyword">static</span> <span class="keywordtype">void</span> addWindowEventListener( <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window, <a class="code" href="classOgre_1_1WindowEventListener.html" title="Callback class used to send out window events to client app">WindowEventListener</a>* listener );
<a name="l00111"></a>00111 
<a name="l00120"></a>00120         <span class="keyword">static</span> <span class="keywordtype">void</span> removeWindowEventListener( <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window, <a class="code" href="classOgre_1_1WindowEventListener.html" title="Callback class used to send out window events to client app">WindowEventListener</a>* listener );
<a name="l00121"></a>00121 
<a name="l00129"></a>00129         <span class="keyword">static</span> <span class="keywordtype">void</span> _addRenderWindow(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window);
<a name="l00130"></a>00130 
<a name="l00138"></a>00138         <span class="keyword">static</span> <span class="keywordtype">void</span> _removeRenderWindow(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00142"></a>00142 <span class="preprocessor">        static LRESULT CALLBACK _WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE &amp;&amp; !defined __OBJC__</span>
<a name="l00145"></a>00145 <span class="preprocessor">        static OSStatus _CarbonWindowHandler(EventHandlerCallRef nextHandler, EventRef event, void* wnd);</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>
<a name="l00148"></a>00148         <span class="comment">//These are public only so GLXProc can access them without adding Xlib headers header</span>
<a name="l00149"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#3c682bc1eab7000d403564b318bae1f9">00149</a>         <span class="keyword">typedef</span> std::multimap&lt;RenderWindow*, WindowEventListener*&gt; WindowEventListeners;
<a name="l00150"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#482ccdb9b1bbdc5439c622399ff4b0b9">00150</a>         <span class="keyword">static</span> WindowEventListeners _msListeners;
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#84c5b63174d4519d9fb0b550e992725b">00152</a>         <span class="keyword">typedef</span> std::vector&lt;RenderWindow*&gt; Windows;
<a name="l00153"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#930c740afae53b8336150b4b9794c96f">00153</a>         <span class="keyword">static</span> Windows _msWindows;
<a name="l00154"></a>00154     };
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
